/*
 * 2013/05/10 hanoi.c
 */

#include <stdio.h>

/*
 *	ハノイプログラムには、s_hanoi.h が必要
 */

#include "s_hanoi.h"

/*
 * ハノイの塔 プログラム
 */

/*
 *	void hanoi ( char *f, char *t, char *w, char *size ) {
 *		size の大きさの塔を、
 *		f から t へ、 w を利用して、移動する
 */

void hanoi ( char *f, char *t, char *w, char *size ) {

  if ( !strcmp ( size, "" ) ) { /* 空っぽだったら*/
	/* する事はない */
  } else {	/* まだ仕事があるなら */
	/* やりたい事は、
		「size の大きさの塔を f から t に動かしたい」事
		そのためには、最終的に、size の大きさの円盤を動かす必要がある。
		そのためには、
			size の大きさの上の塔を t を利用して、一旦、f から w に移し
			size の大きさ円盤を f から t に移し
			size の大きさの上の塔を f を利用して、w から、t に動かせば良い
	*/

	hanoi ( f, w, t, size + 1 );	/* size の円盤の上を片付けた */
	s_hanoi_move ( f, t );			/* f の所にある size の円盤を移動 */
	hanoi ( w, t, f, size + 1 );	/* size の円盤の上を載せる */
  }
}

int main ( void ) {

  /*
   * 最初は "1" に全ての円盤が置いてある
   */

	/*
	 * ハノイで、できること
	 *	 s_hanoi_init() : ハノイプログラムの開始 : 最初に一度だけ呼び出す
	 *   s_hanoi_size ( char *discs ) : ハノイの塔の高さを設定する
	 *   s_hanoi_move ( char *from, char *to ) : from にある円盤を to に移す
	 *   s_hanoi_clear () : 最初の状態に戻す
	 *   s_hanoi_stop() : ハノイプログラムの終了 : return 0 の前に呼び出す
	 */

	s_hanoi_init();
	s_hanoi_size ( "*******" );	// 高さを 7 に設定

	putchar ( '>' );
	putchar ( getchar() );

	hanoi ( "1", "2", "3", "*******" );

	putchar ( '>' );
	putchar ( getchar() );

	s_hanoi_stop();

	return 0;
}

